UNIT kio;
{ Keyboard I/O Unit ...                   Author : Joe da Silva
  Released "AS IS" to the public domain - use at your own risk! }

INTERFACE {kio}

function key_press : boolean;
{Self evident ...}

function get_key : char;
{Self evident ...}

procedure querys (param : byte; prompt : string; var reply : string);
{Get a string parameter from the command line ... fallback to user}

procedure queryw (param : byte; prompt : string; var reply : word);
{Get a numeric (word) parameter from the command line ... fallback to user}

IMPLEMENTATION {kio}

uses
   dos;

type
   alpha = string[10];

var
   regs : registers;   {type is defined in DOS unit}

function key_press : boolean;
const
   keyboard = $16;
   chk_key = $01;
begin {key_press}
   regs.AH := chk_key;
   intr(keyboard,regs);
   key_press := ((regs.Flags and fZero) = 0)
end; {key_press}

function get_key : char;
const
   keyboard = $16;
   getkey = $00;
begin {get_key}
   regs.AH := getkey;
   intr(keyboard,regs);
   get_key := char(regs.AL)
end; {get_key}

procedure querys (param : byte; prompt : string; var reply : string);
begin {querys}
   reply := ParamStr(param);
   if reply = ''
   then
      begin {then}
         write(prompt);
         readln(reply)
      end {then}
end; {querys}

procedure queryw (param : byte; prompt : string; var reply : word);
var
   temp : string;
   ecode : integer;
begin {queryw}
   temp := ParamStr(param);
   repeat
      val(temp,reply,ecode);
      if ecode <> 0
      then
         begin {then}
            write(prompt);
            readln(temp)
         end {then}
   until ecode = 0
end; {queryw}

END. {kio}
